/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.64 Revision 1.85
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.64 2008/06/25 21:35:27 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.85 2012/04/07 10:12:21 hd_brummy Exp $
4
5# @ECLASS: vdr-plugin.eclass
6# @MAINTAINER:
7# vdr@gentoo.org
8# @BLURB: common vdr plugin ebuild functions
9# @DESCRIPTION:
10# Eclass for easing maitenance of vdr plugin ebuilds
11
12# Authors:
13# Matthias Schwarzott <zzam@gentoo.org>
14# Joerg Bornkessel <hd_brummy@gentoo.org>
15# Christian Ruppert <idl0r@gentoo.org>
16
17# Plugin config file installation:
4# 18#
5# Author: 19# A plugin config file can be specified through the $VDR_CONFD_FILE variable, it
6# Matthias Schwarzott <zzam@gentoo.org> 20# defaults to ${FILESDIR}/confd. Each config file will be installed as e.g.
7# Joerg Bornkessel <hd_brummy@gentoo.org> 21# ${D}/etc/conf.d/vdr.${VDRPLUGIN}
8 22
9# vdr-plugin.eclass 23# Installation of rc-addon files:
24# NOTE: rc-addon files must be valid shell scripts!
10# 25#
11# eclass to create ebuilds for vdr plugins 26# Installing rc-addon files is basically the same as for plugin config files
27# (see above), it's just using the $VDR_RCADDON_FILE variable instead.
28# The default value when $VDR_RCADDON_FILE is undefined is:
29# ${FILESDIR}/rc-addon.sh and will be installed as
30# ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
12# 31#
32# The rc-addon files will be sourced by the startscript when the specific plugin
33# has been enabled.
34# rc-addon files may be used to prepare everything that is necessary for the
35# plugin start/stop, like passing extra command line options and so on.
13 36
14# Example ebuild (vdr-femon): 37# Applying your own local/user patches:
38# This is done by using the epatch_user() function of the eutils.eclass.
39# Simply put your patches into one of these directories:
40# /etc/portage/patches/<CATEGORY>/<PF|P|PN>/
41# Quote: where the first of these three directories to exist will be the one to
42# use, ignoring any more general directories which might exist as well.
15# 43#
16# inherit vdr-plugin 44# For more details about it please take a look at the eutils.class.
17# IUSE=""
18# SLOT="0"
19# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)"
20# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/"
21# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz"
22# LICENSE="GPL-2"
23# KEYWORDS="~x86"
24# DEPEND=">=media-video/vdr-1.3.27"
25#
26#
27
28# Installation of a config file for the plugin
29#
30# If ${VDR_CONFD_FILE} is set install this file
31# else install ${FILESDIR}/confd if it exists.
32
33# Gets installed as /etc/conf.d/vdr.${VDRPLUGIN}.
34# For the plugin vdr-femon this would be /etc/conf.d/vdr.femon
35
36
37# Installation of an rc-addon file for the plugin
38#
39# If ${VDR_RCADDON_FILE} is set install this file
40# else install ${FILESDIR}/rc-addon.sh if it exists.
41#
42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
43# (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
44#
45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
46# It could be used for special startup actions for this plugins, or to create the
47# plugin command line options from a nicer version of a conf.d file.
48
49# HowTo use own local patches; Example
50#
51# Add to your /etc/make.conf:
52# VDR_LOCAL_PATCHES_DIR="/usr/local/patch"
53#
54# Add two DIR's in your local patch dir, ${PN}/${PV},
55# e.g for vdr-burn-0.1.0 should be:
56# /usr/local/patch/vdr-burn/0.1.0/
57#
58# all patches which ending on diff or patch in this DIR will automatically applied
59#
60 45
61inherit base multilib eutils flag-o-matic 46inherit base multilib eutils flag-o-matic
47
48if ! has "${EAPI:-0}" 0 1 2 3 4; then
49 die "API of vdr-plugin.eclass in EAPI=\"${EAPI}\" not established"
50fi
62 51
63IUSE="" 52IUSE=""
64 53
65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 54# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66VDRPLUGIN="${PN/#vdrplugin-/}" 55VDRPLUGIN="${PN/#vdrplugin-/}"
71 60
72# works in most cases 61# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 62S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 63
75# depend on headers for DVB-driver 64# depend on headers for DVB-driver
76DEPEND=">=media-tv/gentoo-vdr-scripts-0.3.8 65COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
77 || ( >=media-tv/gentoo-vdr-scripts-0.4.2 >=media-tv/vdrplugin-rebuild-0.2 ) 66
67DEPEND="${COMMON_DEPEND}
68 virtual/linuxtv-dvb-headers"
69RDEPEND="${COMMON_DEPEND}
78 >=app-admin/eselect-vdr-0.0.2 70 >=app-admin/eselect-vdr-0.0.2"
79 media-tv/linuxtv-dvb-headers"
80 71
72# this is a hack for ebuilds like vdr-xineliboutput that want to
73# conditionally install a vdr-plugin
74if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]]; then
75 # make DEPEND conditional
76 IUSE="${IUSE} vdr"
77 DEPEND="vdr? ( ${DEPEND} )"
78 RDEPEND="vdr? ( ${RDEPEND} )"
79fi
81 80
82# New method of storing plugindb 81# New method of storing plugindb
83# Called from src_install 82# Called from src_install
84# file maintained by normal portage-methods 83# file maintained by normal portage-methods
85create_plugindb_file() { 84create_plugindb_file() {
153 done 152 done
154} 153}
155 154
156fix_vdr_libsi_include() 155fix_vdr_libsi_include()
157{ 156{
158 einfo "Fixing include of libsi-headers" 157 #einfo "Fixing include of libsi-headers"
159 local f 158 local f
160 for f; do 159 for f; do
161 sed -i "${f}" \ 160 sed -i "${f}" \
162 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \ 161 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
163 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:' 162 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
183 # To satisfy 1-3 we do this: 182 # To satisfy 1-3 we do this:
184 # Set VDRDIR=/usr/include/vdr 183 # Set VDRDIR=/usr/include/vdr
185 # Set VDRINCDIR=/usr/include 184 # Set VDRINCDIR=/usr/include
186 # Change $(VDRDIR)/include to $(VDRINCDIR) 185 # Change $(VDRDIR)/include to $(VDRINCDIR)
187 186
188 ebegin " Setting paths"
189 sed -i Makefile \ 187 sed -i Makefile \
190 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \ 188 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
191 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \ 189 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
192 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \ 190 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
193 \ 191 \
194 -e 's:-I$(DVBDIR)/include::' \ 192 -e 's:-I$(DVBDIR)/include::' \
195 -e 's:-I$(DVBDIR)::' 193 -e 's:-I$(DVBDIR)::'
196 eend 0
197 194
198 # maybe needed for multiproto: 195 # maybe needed for multiproto:
199 #sed -i Makefile \ 196 #sed -i Makefile \
200 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 197 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
201 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' 198 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
217 214
218 # Disabling file stripping, useful for debugging 215 # Disabling file stripping, useful for debugging
219 sed -i Makefile \ 216 sed -i Makefile \
220 -e '/@.*strip/d' \ 217 -e '/@.*strip/d' \
221 -e '/strip \$(LIBDIR)\/\$@/d' \ 218 -e '/strip \$(LIBDIR)\/\$@/d' \
222 -e '/@.*\$(STRIP)/d' 219 -e 's/STRIP.*=.*$/STRIP = true/'
223 220
224 # Use a file instead of a variable as single-stepping via ebuild 221 # Use a file instead of a variable as single-stepping via ebuild
225 # destroys environment. 222 # destroys environment.
226 touch "${WORKDIR}"/.vdr-plugin_makefile_patched 223 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
227} 224}
228 225
229vdr_add_local_patch() {
230 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
231 echo
232 einfo "Applying local patches"
233 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
234 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
235 done
236 fi
237}
238
239vdr_has_gettext() { 226vdr_has_gettext() {
240 has_version ">=media-video/vdr-1.5.7" 227 has_version ">=media-video/vdr-1.5.7"
241} 228}
242 229
243plugin_has_gettext() { 230plugin_has_gettext() {
244 [[ -d po ]] 231 [[ -d po ]]
232 # some plugins gives false positive results, keep this list short
233 # temporary workout, ToDo: fix the plugins/eclass
234 has_version ">=media-plugins/vdr-streamdev-0.5.0"
245} 235}
246 236
247vdr_i18n_convert_to_gettext() { 237vdr_i18n_convert_to_gettext() {
238 if has_version ">=media-video/vdr-1.7.22"; then
239 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext"
240 else
248 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl" 241 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
242 fi
249 243
250 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then 244 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
251 ewarn "Conversion to gettext disabled in ebuild" 245 ewarn "Conversion to gettext disabled in ebuild"
252 return 1 246 return 1
253 fi 247 fi
283 return 1 277 return 1
284 fi 278 fi
285} 279}
286 280
287vdr_i18n_disable_gettext() { 281vdr_i18n_disable_gettext() {
288 ebegin "Disabling gettext support in plugin" 282 #einfo "Disabling gettext support in plugin"
283
289 # Remove i18n Target if using older vdr 284 # Remove i18n Target if using older vdr
290 sed -i Makefile \ 285 sed -i Makefile \
291 -e '/^all:/s/ i18n//' 286 -e '/^all:/s/ i18n//'
292 eend 0
293} 287}
294 288
295vdr_i18n() { 289vdr_i18n() {
296 if vdr_has_gettext; then 290 if vdr_has_gettext; then
297 einfo "VDR has gettext support" 291 #einfo "VDR has gettext support"
298 if plugin_has_gettext; then 292 if plugin_has_gettext; then
299 einfo "Plugin has gettext support, fine" 293 #einfo "Plugin has gettext support, fine"
300 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then 294 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
301 ewarn "Please remove left over NO_GETTEXT_HACK." 295 ewarn "Please remove unneeded NO_GETTEXT_HACK from ebuild."
302 fi 296 fi
303 else 297 else
304 vdr_i18n_convert_to_gettext 298 vdr_i18n_convert_to_gettext
305 if [[ $? != 0 ]]; then 299 if [[ $? != 0 ]]; then
306 eerror ""
307 eerror "Plugin will have only english OSD texts" 300 einfo "Plugin has no OSD texts or will have only english OSD texts"
308 eerror "it needs manual fixing."
309 fi 301 fi
310 fi 302 fi
311 else 303 else
312 einfo "VDR has no gettext support" 304 #einfo "VDR has no gettext support"
313 if plugin_has_gettext; then 305 if plugin_has_gettext; then
314 vdr_i18n_disable_gettext 306 vdr_i18n_disable_gettext
315 fi 307 fi
316 fi 308 fi
317} 309}
354 elog "To activate a plugin execute this command:" 346 elog "To activate a plugin execute this command:"
355 elog "\teselect vdr-plugin enable <plugin_name> ..." 347 elog "\teselect vdr-plugin enable <plugin_name> ..."
356 elog 348 elog
357} 349}
358 350
351has_vdr() {
352 [[ -f "${VDR_INCLUDE_DIR}"/config.h ]]
353}
359 354
360## exported functions 355## exported functions
361 356
362vdr-plugin_pkg_setup() { 357vdr-plugin_pkg_setup() {
363 # -fPIC is needed for shared objects on some platforms (amd64 and others) 358 # -fPIC is needed for shared objects on some platforms (amd64 and others)
364 append-flags -fPIC 359 append-flags -fPIC
365 360
361 # Plugins need to be compiled with position independent code, otherwise linking
362 # VDR against it will fail
363 if has_version ">=media-video/vdr-1.7.13"; then
364 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
365 fi
366
366 # Where should the plugins live in the filesystem 367 # Where should the plugins live in the filesystem
367 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins" 368 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
368 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums" 369 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
369 370
370 # was /usr/lib/... some time ago 371 # was /usr/lib/... some time ago
374 # Pathes to includes 375 # Pathes to includes
375 VDR_INCLUDE_DIR="/usr/include/vdr" 376 VDR_INCLUDE_DIR="/usr/include/vdr"
376 DVB_INCLUDE_DIR="/usr/include" 377 DVB_INCLUDE_DIR="/usr/include"
377 378
378 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale" 379 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
380 if has_version ">=media-video/vdr-1.6.0_p2-r7"; then
381 LOCDIR="/usr/share/locale"
382 else
379 LOCDIR="/usr/share/vdr/locale" 383 LOCDIR="/usr/share/vdr/locale"
384 fi
385
386 if ! has_vdr; then
387 # set to invalid values to detect abuses
388 VDRVERSION="eclass_no_vdr_installed"
389 APIVERSION="eclass_no_vdr_installed"
390
391 if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]] && ! use vdr; then
392 einfo "VDR not found!"
393 else
394 # if vdr is required
395 die "VDR not found!"
396 fi
397 return
398 fi
380 399
381 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 400 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
382 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 401 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
383 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 402 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
384 403
385 einfo "Compiling against" 404 einfo "Compiling against"
386 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]" 405 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
406
407
408 if [ -n "${VDR_LOCAL_PATCHES_DIR}" ]; then
409 eerror "Using VDR_LOCAL_PATCHES_DIR is deprecated!"
410 eerror "Please move all your patches into"
411 eerror "${EROOT}/etc/portage/patches/${CATEGORY}/${P}"
412 eerror "and remove or unset the VDR_LOCAL_PATCHES_DIR variable."
413 die
414 fi
415}
416
417vdr-plugin_src_util() {
418 while [ "$1" ]; do
419 case "$1" in
420 all)
421 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
422 ;;
423 prepare|all_but_unpack)
424 vdr-plugin_src_util add_local_patch patchmakefile i18n
425 ;;
426 unpack)
427 base_src_unpack
428 ;;
429 add_local_patch)
430 cd "${S}" || die "Could not change to plugin-source-directory!"
431 epatch_user
432 ;;
433 patchmakefile)
434 cd "${S}" || die "Could not change to plugin-source-directory!"
435 vdr_patchmakefile
436 ;;
437 i18n)
438 cd "${S}" || die "Could not change to plugin-source-directory!"
439 vdr_i18n
440 ;;
441 esac
442
443 shift
444 done
387} 445}
388 446
389vdr-plugin_src_unpack() { 447vdr-plugin_src_unpack() {
390 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 448 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
391 eerror "Wrong use of vdr-plugin.eclass." 449 eerror "Wrong use of vdr-plugin.eclass."
392 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 450 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
393 echo 451 echo
394 eerror "Please report this at bugs.gentoo.org." 452 eerror "Please report this at bugs.gentoo.org."
395 die "vdr-plugin_pkg_setup not called!" 453 die "vdr-plugin_pkg_setup not called!"
396 fi 454 fi
397 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n 455 if [ -z "$1" ]; then
456 case "${EAPI:-0}" in
457 2|3|4)
458 vdr-plugin_src_util unpack
459 ;;
460 *)
461 vdr-plugin_src_util all
462 ;;
463 esac
464
465 else
466 vdr-plugin_src_util $@
467 fi
468}
469
470vdr-plugin_src_prepare() {
471 base_src_prepare
472 vdr-plugin_src_util prepare
473}
474
475vdr-plugin_src_compile() {
476 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
398 477
399 while [ "$1" ]; do 478 while [ "$1" ]; do
400 479
401 case "$1" in 480 case "$1" in
402 all_but_unpack) 481 copy_source)
403 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
404 ;;
405 unpack)
406 base_src_unpack
407 ;;
408 add_local_patch)
409 cd "${S}" || die "Could not change to plugin-source-directory!"
410 vdr_add_local_patch
411 ;;
412 patchmakefile)
413 cd "${S}" || die "Could not change to plugin-source-directory!"
414 vdr_patchmakefile
415 ;;
416 i18n)
417 cd "${S}" || die "Could not change to plugin-source-directory!"
418 vdr_i18n
419 ;;
420 esac
421
422 shift
423 done
424}
425
426vdr-plugin_src_compile() {
427 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
428
429 while [ "$1" ]; do
430
431 case "$1" in
432 prepare)
433 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 482 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
434 ;; 483 ;;
435 compile) 484 compile)
436 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then 485 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
437 eerror "Wrong use of vdr-plugin.eclass." 486 eerror "Wrong use of vdr-plugin.eclass."
441 eerror "Please report this at bugs.gentoo.org." 490 eerror "Please report this at bugs.gentoo.org."
442 die "vdr-plugin_src_unpack not called!" 491 die "vdr-plugin_src_unpack not called!"
443 fi 492 fi
444 cd "${S}" 493 cd "${S}"
445 494
495 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
496
446 emake ${BUILD_PARAMS} \ 497 emake ${BUILD_PARAMS} \
447 ${VDRPLUGIN_MAKE_TARGET:-all} \ 498 ${BUILD_TARGETS} \
448 LOCALEDIR="${TMP_LOCALE_DIR}" \ 499 LOCALEDIR="${TMP_LOCALE_DIR}" \
449 LIBDIR="${S}" \ 500 LIBDIR="${S}" \
450 TMPDIR="${T}" \ 501 TMPDIR="${T}" \
451 || die "emake failed" 502 || die "emake failed"
452 ;; 503 ;;
539vdr-plugin_pkg_postrm() { 590vdr-plugin_pkg_postrm() {
540 delete_orphan_plugindb_file 591 delete_orphan_plugindb_file
541} 592}
542 593
543vdr-plugin_pkg_config() { 594vdr-plugin_pkg_config() {
544 ewarn "emerge --config ${PN} is no longer supported" 595:
545 vdr-plugin_print_enable_command
546} 596}
547 597
598case "${EAPI:-0}" in
599 2|3|4)
600 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
601 ;;
602 *)
548EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 603 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
604 ;;
605esac

Legend:
Removed from v.1.64  
changed lines
  Added in v.1.85

  ViewVC Help
Powered by ViewVC 1.1.20